<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        // gán sự kiện cho nút sửa
        $("#table-users").on("click", ".edit-user", function () {
            onBtnEditUserClick(this);
        });
        // gán sự kiện cho nút xóa
        $("#table-users").on("click", ".delete-user", function () {
            onBtnDeleteUserClick(this);
        });
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        // load data to table
        requestDataAndLoadToTable();
    }

    // gán sự kiện cho nút edit
    function onBtnEditUserClick(paramEdit) {
        var vUserId = $(paramEdit).data("id");
        console.log(vUserId);
        const vDETAIL_FROM_URL = "updateUser.html";
        var vUrlToOpePage = vDETAIL_FROM_URL + "?id=" + vUserId;
        window.location.href = vUrlToOpePage;
    }

    // gán sự kiện cho nút Delete
    function onBtnDeleteUserClick(paramDelete) {
        var vUserId = $(paramDelete).data("id");
        console.log(vUserId);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi API và load dữ liệu vào user table
    function requestDataAndLoadToTable() {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            success: function (paramUsers) {
                loadUserToTable(paramUsers);
            },
            error: function (paramError) {
                console.log(paramError.status);
            }
        });
    }


    // hàm load dữ liệu user vào table
    // input: mảng users
    function loadUserToTable(paramUsers) {
        var vUserTable = $("#table-users");
        for (var bI = 0; bI < paramUsers.length; bI++) {
            // tạo ra dòng, gắn vào table
            var bNewRow = $("<tr>").appendTo(vUserTable);
            // tạo ra từng ô, gán dữ liệu cho ô và gắn vào dòng mới vừa tạo ở trên
            $("<td>", { html: paramUsers[bI].id }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].firstname }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].lastname }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].country }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].subject }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].customerType }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].registerStatus }).appendTo(bNewRow);
            // ô action
            var bActionCell = $("<td>").appendTo(bNewRow);
            // nút Sửa
            $("<button>", {
                html: "Sửa",
                class: "btn btn-primary mr-1 edit-user"
            }).data("id", paramUsers[bI].id)
                .appendTo(bActionCell);

            // Nút Xóa
            $("<button>", {
                html: "Xóa",
                class: "btn btn-danger delete-user"
            }).data("id", paramUsers[bI].id)
                .appendTo(bActionCell);
        }
    }
</script>

</html>